# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`jail::setup`](#jailsetup): Lay down the global configuration for jail.conf as well as create the needed directories and/or zfs mountpoints.

### Resource types

* [`jail`](#jail): The jail ID for running jails  This is a read-only property.
* [`jail_release`](#jail_release): The release to fetch

## Classes

### <a name="jailsetup"></a>`jail::setup`

Lay down the global configuration for jail.conf as well as create the needed directories and/or zfs mountpoints.

#### Parameters

The following parameters are available in the `jail::setup` class:

* [`package_name`](#package_name)

##### <a name="package_name"></a>`package_name`

Data type: `String[1]`

name of the package that provides iocage

Default value: `'py36-iocage'`

## Resource types

### <a name="jail"></a>`jail`

The jail ID for running jails

This is a read-only property.

#### Properties

The following properties are available in the `jail` type.

##### `boot`

Valid values: `on`, `off`

Either on or off

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

##### `fstab`

A list of fstab entries for this jail to be mounted into. By default these are nullfs mounts.

##### `ip4_addr`

Interface|Address[,Interface|Address[...]]

Changes to this property will cause a restart of the jail.

##### `ip6_addr`

Interface|Address[,Interface|Address[...]]

Changes to this property will cause a restart of the jail.

##### `jail_zfs`

Valid values: `on`, `off`

Enable the jail_zfs

##### `jid`

The jail ID for running jails

This is a read-only property.

##### `memoryuse`

Cap the RAM usage of a jail

##### `pcpu`

Cap the CPU usage of a jail

##### `properties`

All properties (that deviate from the default)

##### `quota`

Set maximum disk usage for a jail

##### `release`

FreeBSD release of this jail. `EMPTY` if this is a Linux jail.  `release` and `template` are mutually exclusive.

Changes to this property will lead to destruction and rebuild of the jail.

##### `rlimits`

Valid values: `on`, `off`

Enable|Disable Limits

##### `state`

Valid values: `up`, `down`

Either running or stopped

##### `template`

Template jail to base this one off. `release` and `template` are mutually exclusive.

Changes to this property will lead to destruction and rebuild of the jail.

##### `type`

Valid values: `jail`, `basejail`, `template`

Type of jail. This can be `jail`, `basejail`, or `template`

Changes to this property will lead to destruction and rebuild of the jail.

Default value: `jail`

#### Parameters

The following parameters are available in the `jail` type.

* [`allow_rebuild`](#allow_rebuild)
* [`allow_restart`](#allow_restart)
* [`name`](#name)
* [`pkglist`](#pkglist)
* [`provider`](#provider)
* [`user_data`](#user_data)

##### <a name="allow_rebuild"></a>`allow_rebuild`

Valid values: ``true``, ``false``

Allow destroying! and rebuilding of this jail

Default value: ``true``

##### <a name="allow_restart"></a>`allow_restart`

Valid values: ``true``, ``false``

Allow restarting of this jail

Default value: ``true``

##### <a name="name"></a>`name`

Valid values: `%r{^[a-zA-Z0-9_-]+$}`

namevar

The name (and hostname) of the jail

##### <a name="pkglist"></a>`pkglist`

A list of packages to be installed in this jail before startup

##### <a name="provider"></a>`provider`

The specific backend to use for this `jail` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

##### <a name="user_data"></a>`user_data`

Rendered content to pipe to a jailed shell upon creation

Changes to this property will lead to destruction and rebuild of the jail.

### <a name="jail_release"></a>`jail_release`

The release to fetch

#### Properties

The following properties are available in the `jail_release` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

#### Parameters

The following parameters are available in the `jail_release` type.

* [`name`](#name)
* [`provider`](#provider)

##### <a name="name"></a>`name`

namevar

The release to fetch

##### <a name="provider"></a>`provider`

The specific backend to use for this `jail_release` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

